/*
*  This script defines functions used to show and to remove duplicates within ManageDuplicates.xul
*
* Author: Stphane BERTIN
* http://bookmarkdd.mozdev.org
*
*/

var URLnum = 0;
var DupNum = 0;
var Totalnum = 0;
var DuplicatesBundle = document.getElementById('duplicates-strings');
var URLParents = new Array();
var URLrdfNodes = new Array();

var URLlist = document.getElementById("URLlist");
var FolderslistJS = document.getElementById("Folderslist");


function onLoad(WinArgs) {
    DupNum = new String(WinArgs[1]);
    Totalnum = new String(WinArgs[2]);
    setMessage(DupNum, Totalnum);


    if("arguments" in window && WinArgs.length > 0) {
	var listURL = WinArgs[0];
    }
    for(var i=0;i<listURL.length;i++){ addURL(URLlist,listURL[i],i); }
    if (listURL.length>15){URLlist.setAttribute('rows','15');}


    if(UserPrefs.getPref("bool","URLselect.2clicks")) {
	URLlist.setAttribute('ondblclick','ShowFolders(event,this.selectedItem);');
    } else {
	URLlist.setAttribute('onclick','ShowFolders(event,this.selectedItem);');
    }
}


function addURL(list,value,index) {
    list.appendItem(value,index);
}

function setMessage(Num, Total){
    var message ="";
    try {
	message = DuplicatesBundle.getFormattedString("DuplicatesFound", [Num, Total]);
    }  catch(e){
    	message = "You are using a localisation which is not supported !";
    }

    var messageParent = document.getElementById("Find-message");
    messageParent.setAttribute('value',message);
}

var SelectedURL = "";

function ShowFolders(aEvent,aItem){
    if(aEvent.button !=0) return false;
    var folders = null;

    removeAllItems("Folderslist");

    // Each time an item is selected 'isBookmarked' is executed.
    try { folders = Bookmarkdd.isBookmarked(aItem.label); } catch(e) { return false; }

    URLnum = folders.parents.length;
    SelectedURL = aItem;

    if(URLnum > 0) {
	URLParents = folders.parents;
	URLrdfNodes = folders.RDFnodes;
	document.getElementById('b_delete').removeAttribute('disabled');
    } else {
	return alert("ERROR: impossible to find URLs folder path !!");
    }

    for(var i=0;i<URLnum;i++){ addURL(FolderslistJS,URLParents[i],i); }

    document.getElementById("Folderslist").setAttribute('rows',eval(URLnum+1));
    var TruncatedUrl = aItem.label.substr(0,150);
    document.getElementById("description-url").setAttribute('value',TruncatedUrl);

    window.sizeToContent();

    return true;
}


function removeAllItems(myListBox) {

    var box = document.getElementById(myListBox);
    var rowCount = box.getRowCount();
    for( var i = rowCount; i > 0; i-- ) {
	box.removeItemAt(0);
    }

}


function deleteSelection() {
    var count = FolderslistJS.selectedCount;
    for(var i=0;i<count;i++){
	if(!removeURL(FolderslistJS.selectedItems[i])) continue;
	FolderslistJS.removeItemAt(FolderslistJS.getIndexOfItem(FolderslistJS.selectedItems[i]));

	//If there is only one folder disable delete button to avoid remove of all URL references
	if (FolderslistJS.getRowCount()<2) {
	    document.getElementById('b_delete').setAttribute('disabled','true');
	    URLlist.removeItemAt(URLlist.getIndexOfItem(SelectedURL));
	    DupNum--;
	    setMessage(DupNum, Totalnum);
	}
    }
    return true;
}

function removeURL(aItem){

    var URLPath = URLParents[aItem.value];
    var TruncatedUrl = SelectedURL.label.substr(0,150);
    var message = DuplicatesBundle.getFormattedString("Remove-Confirmation", [TruncatedUrl, URLPath]);

    var result = true;
    //If confirmation is not asked delete URL
    if(UserPrefs.getPref("bool","removeURL.confirmation")) result = confirm(message);
    if (result) {
	var selection = Bookmarkdd.createSelection(URLrdfNodes[aItem.value]);
	//Remove bookmark in Bookmarks
	BookmarksCommand.deleteBookmark(selection);
	URLnum--;
	return true;
    }
    return false;
}



function openbmProperties(aItem,aEvent){
    //Show Properties if context Click button --> rigth mouse click
    //if (aEvent.button != 2) return false;
    if (aEvent.button != 2) {
	//var selection = Bookmarkdd.createSelection(URLrdfNodes[aItem.value]);
    	//BookmarksCommand.createContextMenu(aEvent,selection);
	//return true;
	return false;
    } else {
    var value = {};
    openDialog("chrome://browser/content/bookmarks/bookmarksProperties.xul", "bmProperties", "centerscreen,chrome,modal,resizable", URLrdfNodes[aItem.value].Value, value);
    return value.ok;
    }
}
 
 /*
//TODO Try to use bookmarks-context-menu on listbox
function showMenu(event,aItem){
    //menupopup id="bookmarks-context-menu"
    //document.popupNode.property.id = URLrdfNodes[aItem.value].Value;
    //BookmarksCommand.createContextMenu(event);
    //openDialog("chrome://browser/content/bookmarks/bookmarksManager.xul", "", "chrome,all,dialog=no", URLrdfNodes[aItem.value].Value);

    BookmarksMenu.createContextMenu(event);
    openDialog("chrome://browser/content/bookmarks/bookmarksPanel.xul", "", "chrome,all,dialog=no", URLrdfNodes[aItem.value].Value);
}
*/

